/*
 * Created by SharpDevelop.
 * User: LYCJ
 * Date: 20/11/2006
 * Time: 21:02
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
 
using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.IO;
using System.Runtime.InteropServices;
using System.Runtime.Serialization;
using System.Windows.Forms;

namespace Cake3.Cmarc
{
	
	internal class Win32API
    {
        [DllImport("kernel32.dll")]
        internal static extern IntPtr LoadLibrary(string ArchiverName);
        [DllImport("kernel32.dll")]
        internal static extern bool FreeLibrary(IntPtr hModule);
        [DllImport("kernel32.dll")]
        internal static extern IntPtr GetProcAddress(IntPtr hModule, string procname);
        [DllImport("kernel32.dll")]
        internal static extern bool DosDateTimeToFileTime(ushort wFatDate, ushort wFatTime, out Int64 lpFileTime);

    }
	
	/// <summary>
	/// Description of ArchiverBase.
	/// </summary>
	public abstract class ArchiverBase : IDisposable
	{		
		public const int FNAME_MAX32 = 512;
		[StructLayout(LayoutKind.Sequential)]
        public struct INDIVIDUALINFO
        {
            public UInt32 dwOriginalSize;
            public UInt32 dwCompressedSize;
            public UInt32 dwCRC;
            public UInt32 uFlag;
            public UInt32 uOSType;
            public UInt16 wRatio;
            public UInt16 wDate;
            public UInt16 wTime;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = FNAME_MAX32 + 1)]
            public string szFileName;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 3)]
            public string dummy1;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 8)]
            public string szAttribute;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 8)]
            public string szMode;
        }

        [StructLayout(LayoutKind.Sequential)]        
        public struct LPEXTRACTINGINFO
        {
        	UInt32 DwFileSize;
        	UInt32 DwWriteSize;
        	[MarshalAs(UnmanagedType.ByValTStr, SizeConst = FNAME_MAX32 + 1)]
        	public string SzSourceFileName;
        	[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 3)]
        	public string Dummy1;
        	[MarshalAs(UnmanagedType.ByValTStr, SizeConst = FNAME_MAX32 + 1)]
        	public string SzDestFileName;
        	[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 3)]
        	public string Dummy;        	
        }
        
        [StructLayout(LayoutKind.Sequential)]        
        public struct LPEXTRACTINGINFOEX
        {
        	LPEXTRACTINGINFO ExInfo;
        	UInt32 DwCompressedSize;
        	UInt32 DwCRC;
        	UInt16 UOSType;
        	UInt32 WRatio;
        	UInt16 WDate;
        	UInt16 WTime;
        	[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 8)]
        	public string SzAttribute;
        	[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 8)]
        	public string SzMode;
        }        
        
		protected IntPtr hArchiver;
		protected UInt32 WM_ARCEXTRACT = 0;
		protected IntPtr FOwnerWindow = IntPtr.Zero;
		
		//Commands
		protected string dllPath  = "Unlha32.dll";
		protected string archiverName = "UnLha";		
			#region Non-interactive (OpenArchive not required) api	
			protected string _checkArchive 		{ get { return archiverName + "CheckArchive"; } }	
			protected string _exec 				{ get { return archiverName; } }	
			protected string _getVersion 		{ get { return archiverName + "GetVersion"; } }
			#endregion
			#region Interactive (OpenArchive required) api
			protected string _openArchive 		{ get { return archiverName + "OpenArchive"; } }
			protected string _closeArchive 		{ get { return archiverName + "CloseArchive"; } }
			protected string _findFirst 		{ get { return archiverName + "FindFirst"; } }
			protected string _findNext	 		{ get { return archiverName + "FindNext"; } }			
			protected string _setOwnerWindowEx	{ get { return archiverName + "SetOwnerWindowEx"; } }	
			protected string _killOwnerWindowEx	{ get { return archiverName + "KillOwnerWindowEx"; } }	
			protected string _callBackEnabled	{ get { return archiverName + "CallBackEnabled"; } }	
			#endregion		
		
		//Delegate
			#region Non-interactive (OpenArchive not required) api				
			public delegate bool ArchiverCheckArchive([MarshalAs(UnmanagedType.LPStr)]string FileName, Int32 Mode);
			public delegate Int32 ArchiverExec(IntPtr hWnd, [MarshalAs(UnmanagedType.LPStr)]string CmdLine,
                                                StringBuilder Output, UInt32 Size);
			public delegate UInt16 ArchiverGetVersion();
			#endregion
			#region Interactive (OpenArchive required) api
			public delegate IntPtr ArchiverOpenArchive(IntPtr hWnd, string FileName, UInt32 Mode);
        	public delegate Int32 ArchiverCloseArchive(IntPtr hArc);
        	public delegate Int32 ArchiverFindFirst(IntPtr hArc, string WildName, ref INDIVIDUALINFO SubInfo);
        	public delegate Int32 ArchiverFindNext(IntPtr hArc, ref INDIVIDUALINFO SubInfo);
        	public delegate bool SetOwnerWindowEx(IntPtr hWnd, IntPtr LpArcProc);
        	public delegate bool KillOwnerWindowEx(IntPtr hWnd);
        	public delegate bool CallBackEnabled();
			#endregion
			
		//Delegate Function
			#region Non-interactive (OpenArchive not required) api		
			public ArchiverCheckArchive _ArchiverCheckArchive;
			public ArchiverExec _ArchiverExec;
			public ArchiverGetVersion _ArchiverGetVersion;
			#endregion			
			#region Interactive (OpenArchive required) api
			public ArchiverOpenArchive _ArchiverOpenArchive;
        	public ArchiverCloseArchive _ArchiverCloseArchive;
        	public ArchiverFindFirst _ArchiverFindFirst;
        	public ArchiverFindNext _ArchiverFindNext;
        	public SetOwnerWindowEx _SetOwnerWindowEx;
        	public KillOwnerWindowEx _KillOwnerWindowEx;
        	public CallBackEnabled _CallBackEnabled;
			#endregion
		
		protected void LoadArchiver()
        {
            hArchiver = Win32API.LoadLibrary(dllPath);
            if (hArchiver == IntPtr.Zero) 
            	{ throw new Exception("Cannot load " + dllPath); }
            LoadFunction();
        }
		
		protected void LoadFunction()
        {
            IntPtr procaddr;
            #region Non-interactive (OpenArchive not required) api		            
            procaddr = Win32API.GetProcAddress(hArchiver, _checkArchive);
            if (hArchiver == IntPtr.Zero) { throw new Exception("Cannot load command " + _checkArchive); }                
            _ArchiverCheckArchive = (ArchiverCheckArchive)Marshal.GetDelegateForFunctionPointer(procaddr, typeof(ArchiverCheckArchive));
            
            procaddr = Win32API.GetProcAddress(hArchiver, _exec);
            if (hArchiver == IntPtr.Zero) { throw new Exception("Cannot load command " + _exec); }                
            _ArchiverExec = (ArchiverExec)Marshal.GetDelegateForFunctionPointer(procaddr, typeof(ArchiverExec));
            
            procaddr = Win32API.GetProcAddress(hArchiver, _getVersion);
            if (hArchiver == IntPtr.Zero) { throw new Exception("Cannot load command " + _getVersion); }                
            _ArchiverGetVersion = (ArchiverGetVersion)Marshal.GetDelegateForFunctionPointer(procaddr, typeof(ArchiverGetVersion));
            #endregion
            #region Interactive (OpenArchive required) api
            procaddr = Win32API.GetProcAddress(hArchiver, _openArchive);
            if (hArchiver == IntPtr.Zero) { throw new Exception("Cannot load command " + _openArchive); }                
            _ArchiverOpenArchive = (ArchiverOpenArchive)Marshal.GetDelegateForFunctionPointer(procaddr, typeof(ArchiverOpenArchive));
            
            procaddr = Win32API.GetProcAddress(hArchiver, _closeArchive);
            if (hArchiver == IntPtr.Zero) { throw new Exception("Cannot load command " + _closeArchive); }                
            _ArchiverCloseArchive = (ArchiverCloseArchive)Marshal.GetDelegateForFunctionPointer(procaddr, typeof(ArchiverCloseArchive));
            
            procaddr = Win32API.GetProcAddress(hArchiver, _findFirst);
            if (hArchiver == IntPtr.Zero) { throw new Exception("Cannot load command " + _findFirst); }                
            _ArchiverFindFirst = (ArchiverFindFirst)Marshal.GetDelegateForFunctionPointer(procaddr, typeof(ArchiverFindFirst));
           
            procaddr = Win32API.GetProcAddress(hArchiver, _findNext);
            if (hArchiver == IntPtr.Zero) { throw new Exception("Cannot load command " + _findNext); }                
            _ArchiverFindNext = (ArchiverFindNext)Marshal.GetDelegateForFunctionPointer(procaddr, typeof(ArchiverFindNext));
            
//            procaddr = Win32API.GetProcAddress(hArchiver, _setOwnerWindowEx);
//            if (hArchiver == IntPtr.Zero) { throw new Exception("Cannot load command " + _setOwnerWindowEx); }                
//            _SetOwnerWindowEx = (SetOwnerWindowEx)Marshal.GetDelegateForFunctionPointer(procaddr, typeof(SetOwnerWindowEx));
//            
//            procaddr = Win32API.GetProcAddress(hArchiver, _killOwnerWindowEx);
//            if (hArchiver == IntPtr.Zero) { throw new Exception("Cannot load command " + _killOwnerWindowEx); }                
//            _KillOwnerWindowEx = (KillOwnerWindowEx)Marshal.GetDelegateForFunctionPointer(procaddr, typeof(KillOwnerWindowEx));
//            
//            procaddr = Win32API.GetProcAddress(hArchiver, _callBackEnabled);
//            if (hArchiver == IntPtr.Zero) { throw new Exception("Cannot load command " + _callBackEnabled); }                
//            _CallBackEnabled = (CallBackEnabled)Marshal.GetDelegateForFunctionPointer(procaddr, typeof(CallBackEnabled));
            
            #endregion                       
		}
		
		/// <summary>
		/// e.g. archiveName = "unlha";
		/// </summary>
		protected abstract void SetArchiverName();		
		internal abstract string GetExtractCommand(Cake3.ExtractOptions options, string filename);
		internal virtual string GetAddCommand(Cake3.AddOptions options, string filename)
		{
			return "";
		}
		internal virtual string GetDeleteCommand(Cake3.DeleteOptions options, string filename)
		{
			return "";
		}
		
		internal virtual string GetTestCommand(string archiveName)
		{									
			StringBuilder sb = new StringBuilder();
			sb.Append("t ");
			sb.Append('"' + archiveName + '"');
			return sb.ToString();
		}
		internal virtual string GetSFXCommand(Cake3.SFXOptions options)
		{
			return "";
		}
		
		public ArchiverBase()
		{		
			SetArchiverName();
			if (!Utils.verifyDllPath(ref dllPath))
				throw new Exception("Cannot load " + dllPath + ".");			
			LoadArchiver();			
		}
		
		void IDisposable.Dispose()
        {
            Win32API.FreeLibrary(hArchiver);
        }
		
		protected string getFullPath(string filePath, ref string basePath)
		{
			basePath = Utils.GetFileDrive(filePath) + @":\";
			return Utils.RemoveFileDrive(filePath);
		}
		
		protected string getRelativePath(string filePath, ref string basePath)
		{			
			if (basePath == "")
			{
				getFullPath(filePath, ref basePath);
			}
							
			string retVal;
			basePath = Utils.RemoveSlash(basePath); //06-09-07
//			filePath = filePath;
			string path = Utils.ExtractFilePath(filePath);
			string name = Utils.ExtractFileName(filePath);
			
			if (path.IndexOf(basePath) == 0)
				retVal = path.Substring(basePath.Length);
			else retVal = path;
			
			if (retVal != "")
				retVal += @"\";
			
			return CmarcArchiver.ModifySlashFromCak(retVal + name);
		}
		
		
	}
}
