/*
 * Created by SharpDevelop.
 * User: LYCJ
 * Date: 29/11/2006
 * Time: 15:40
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Collections.Generic;
using System.Text;

namespace Cake3.Cmarc
{
	/// <summary>
	/// Description of ArjBase.
	/// </summary>
	public class BhBase : ArchiverBase
	{		
		private const string DLLPATH  = "Bh32.dll";
		private const string ARCHIVER = "Bh";
		
		public BhBase() : base()
		{
			
		}
		
		public static List<string> SupportedExtensions()
		{ 
			List<string> retVal = new List<string>();
			
			foreach (ArchiveType at in SupportedArchiveTypes(""))
				foreach (string ext in at.SupportedExtensions.Split(';'))
				         retVal.Add(ext);

			return retVal;		
		}
		
		public static List<ArchiveType> SupportedArchiveTypes(string archiver)
		{
			List<ArchiveType> retVal = new List<ArchiveType>();
			if (Utils.verifyDllPath(DLLPATH))
			{
				retVal.Add(new ArchiveType(archiver, "psf,bh", 0, false, true, false, false));
			}								
			return retVal;
		}
		
		protected override void SetArchiverName()
        {
            archiverName = ARCHIVER;
            dllPath = DLLPATH;            
        }
		
		internal override string GetExtractCommand(Cake3.ExtractOptions options, string filename)
		{
			if (options.archiveName == "") 
				throw new Exception("No archive specified!");
						
			StringBuilder sb = new StringBuilder();
			sb.Append("e ");
			sb.Append('"' + options.archiveName + '"' + ' ');			
			sb.Append('"' + options.ExtractFolderParsed + '"' + ' ');
//			sb.Append('"' + filename + '"' + ' ');					
									
			return sb.ToString();
		}
	}
}
