/*
 * Created by SharpDevelop.
 * User: LYCJ
 * Date: 29/11/2006
 * Time: 15:26
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Collections.Generic;
using System.Text;

namespace Cake3.Cmarc
{
	/// <summary>
	/// Description of XacRettBase.
	/// </summary>
	public class XacRettBase : ArchiverBase
	{	
		private const string DLLPATH  = "Xacrett.dll";
		private const string ARCHIVER = "XacRett";
		
		public XacRettBase() : base()
		{
			
		}
		
		public static List<string> SupportedExtensions()
		{ 
			List<string> retVal = new List<string>();
			
			foreach (ArchiveType at in SupportedArchiveTypes(""))
				foreach (string ext in at.SupportedExtensions.Split(';'))
				         retVal.Add(ext);

			return retVal;		
		}
		
		public static List<ArchiveType> SupportedArchiveTypes(string archiver)
		{
			List<ArchiveType> retVal = new List<ArchiveType>();
			if (Utils.verifyDllPath(DLLPATH))
			{
//				retVal.Add(new ArchiveType(archiver, "imp", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "zoo", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "arc", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "cpt", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "pit", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "arg", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "asd", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "dz", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "sh", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "zac", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "bin", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "car", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "frz", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "spl", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "jam", 0, true, true, false, false));
//				retVal.Add(new ArchiveType(archiver, "bqx", 0, true, true, false, false));
				
				
				retVal.Add(new ArchiveType(archiver, "b64", 0, true, true, false, false, "/x"));				
				retVal.Add(new ArchiveType(archiver, "uue,xxe", 0, true, true, false, false, "/x"));				
				retVal.Add(new ArchiveType(archiver, "arc", 0, true, true, false, false, "/x"));
				//arg ??
				retVal.Add(new ArchiveType(archiver, "asd", 0, true, true, false, false, "/x"));				
				retVal.Add(new ArchiveType(archiver, "bel", 0, true, true, false, false, "/x"));
				//bqx ??
				retVal.Add(new ArchiveType(archiver, "cab", 0, true, true, false, false, "/x"));
				retVal.Add(new ArchiveType(archiver, "cab", 2, true, true, false, false, "/x"));
				//car ??
				retVal.Add(new ArchiveType(archiver, "cpt", 0, true, true, false, false, "/x"));
				retVal.Add(new ArchiveType(archiver, "cpio,shar", 0, true, true, false, false, "/x"));	
				retVal.Add(new ArchiveType(archiver, "deb", 0, true, true, false, false, "/x"));
				//dz ??
				retVal.Add(new ArchiveType(archiver, "dmg", 0, true, true, false, false, "/x"));
				retVal.Add(new ArchiveType(archiver, "f,frz", 0, true, true, false, false, "/x"));
				retVal.Add(new ArchiveType(archiver, "hqx", 0, true, true, false, false, "/x"));								
				retVal.Add(new ArchiveType(archiver, "imp", 0, true, true, false, false, "/x"));
				retVal.Add(new ArchiveType(archiver, "jam", 0, true, true, false, false, "/x"));
				retVal.Add(new ArchiveType(archiver, "lha,lzh,lzs", 0, true, true, false, false, "/x"));
				retVal.Add(new ArchiveType(archiver, "macbin", 0, true, true, false, false, "/x"));				
				retVal.Add(new ArchiveType(archiver, "pak,wad", 0, true, true, false, false, "/x"));
				retVal.Add(new ArchiveType(archiver, "pit", 0, true, true, false, false, "/x"));	
				retVal.Add(new ArchiveType(archiver, "rpm", 0, true, true, false, false, "/x"));	
				//sh ??
				//spl ??
				retVal.Add(new ArchiveType(archiver, "yenc", 0, true, true, false, false, "/x"));
				retVal.Add(new ArchiveType(archiver, "yz1", 0, true, true, false, false, "/x"));
				//zac ?/
				retVal.Add(new ArchiveType(archiver, "zip,ear,jar,war,wsz,mskin,bsz,wal,wmz", 0, true, true, false, false, "/x"));
				retVal.Add(new ArchiveType(archiver, "zoo", 0, true, true, false, false, "/x"));
				//zac ??
				retVal.Add(new ArchiveType(archiver, "tar", 0, true, true, false,false, "/x"));
				retVal.Add(new ArchiveType(archiver, "bz2", 0, true, true, false,false, "/x"));
				retVal.Add(new ArchiveType(archiver, "gz", 0, true, true, false,false, "/x")); 
				

				
			}								
			return retVal;
		}
		
		protected override void SetArchiverName()
        {
            archiverName = ARCHIVER;
            dllPath = DLLPATH;
        }
				
		
		internal override string GetExtractCommand(Cake3.ExtractOptions options, string filename)
		{
			if (options.archiveName == "") 
				throw new Exception("No archive specified!");
						
			StringBuilder sb = new StringBuilder();
			sb.Append("x ");
			if (options.dialogless)					
				sb.Append("-n1 "); //Dialogless
			if (options.allowOverwrite)
				sb.Append("-o1 "); //AlwaysOverwrite
			//sb.Append("-j "); Ignore path
			sb.Append('"' + options.archiveName + '"' + ' '); //07-26-07 Extract problem if not extract *
			sb.Append('"' + Utils.AppendSlash(options.ExtractFolderParsed) + '"' + ' ');  
			sb.Append('"' + CmarcArchiver.ModifySlashFromCak(filename) + '\"' + ' ');
									
			return sb.ToString();
		}
	}
}
