/*
 * Created by SharpDevelop.
 * User: LYCJ
 * Date: 26/7/2007
 * Time: 2:01
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.IO;
using System.Text;
using System.Xml;
using Cake3;
using Cake3.Cmarc;
using QuickZip.InstallBuilder;

namespace Cake3.InstallBuild
{
	/// <summary>
	/// Description of InstBuildArchiver.
	/// </summary>
	public class InstBuildArchiver : CakArchiver
	{
		internal override string name {	get { return "ibuild"; }}
		Cake3.Cmarc.ArchiverBase arcBase;
		IntPtr harc;
		bool isWCECabinet = false;
		Hashtable NameList;
		Hashtable SrcNameList;				
		
		public InstBuildArchiver() : base()
		{
			NameList = new Hashtable();
			SrcNameList = new Hashtable();
		}				
		
		internal override void setArchiveName(string anArchive)
		{
			base.setArchiveName(anArchive);
			arcBase = new XacRettBase();
			canList = true;
			canExtract = true;
		}
				
		public override List<ArchiveType> SupportedArchiveTypes()
		{
			List<ArchiveType> retVal = new List<ArchiveType>();			
			retVal.Add(new ArchiveType(name, "cab", 1, true, true, false, false, "/ib"));
			return retVal;
		}
		
		public override bool Open()
		{
			if (archiveOpened)
				return false;
			
			if (Utils.FileExists(archiveName))
				harc = arcBase._ArchiverOpenArchive(IntPtr.Zero, archiveName, 0);
			
			archiveOpened = true;
			return true;
		}
		
		public override bool Close()
		{
			if (!archiveOpened)
				return false;
			
			if (harc != IntPtr.Zero)
				arcBase._ArchiverCloseArchive(harc);
			
			harc = IntPtr.Zero;
			archiveOpened = false;
			return true;
		}
		
		
		bool extractConfigFile(string filename, string path)
		{
			Utils.RemoveFile(path + filename);
			
			string command = arcBase.GetExtractCommand(new ExtractOptions(archiveName, path,
			                                                              new string[] {filename}, true, true),
			                                           filename);;
			StringBuilder output = new StringBuilder(4096);
			Int32 retVal = arcBase._ArchiverExec(IntPtr.Zero, command, output, (UInt32)output.Capacity);
			ErrorMessage ec = Defines.ErrorMessage(retVal);
			return (ec.ErrorName == "NOERROR");
		}
						
		
		public override bool List(string mask)
		{
//			if(OnItemList == null) return false;
			if(harc == IntPtr.Zero) return true;
			
			NameList = new Hashtable();
			SrcNameList = new Hashtable();
			List<ArchiverBase.INDIVIDUALINFO> FileNameList = new List<ArchiverBase.INDIVIDUALINFO>();
			
			DispMessage(Defines.ErrorMessage("PROCESSLIST"), archiveName);
			
			ArchiverBase.INDIVIDUALINFO subInfo = new ArchiverBase.INDIVIDUALINFO();
			ProjectData Data = null;
			
			#region PollFileList			
			string idxFile = "";
			if (arcBase._ArchiverFindFirst(harc, "*", ref subInfo) == 0)
			{
				string ext = Utils.ExtractFileExt(subInfo.szFileName.ToLower());
				if (ext.EndsWith(".000")) idxFile = subInfo.szFileName;
				else if ((subInfo.szFileName == "_setup.xml") && (idxFile == "")) idxFile = subInfo.szFileName;
				else FileNameList.Add(subInfo);

				while (arcBase._ArchiverFindNext(harc, ref subInfo) == 0)
				{
					ext = Utils.ExtractFileExt(subInfo.szFileName.ToLower());
					if (ext.EndsWith(".000")) idxFile = subInfo.szFileName;
					else if ((subInfo.szFileName == "_setup.xml") && (idxFile == "")) idxFile = subInfo.szFileName;
					else FileNameList.Add(subInfo);					
				}						
			}
			#endregion
			#region ReadIdxFile			
			if (idxFile != "")
			{
				if (idxFile == "_setup.xml")
				{
					if (extractConfigFile(subInfo.szFileName, Utils.GetTempPath()))
					{
						string configFile = Utils.GetTempPath() + CmarcArchiver.ModifySlashToCak(idxFile);
	 					XmlTextReader reader = new XmlTextReader(new FileStream(configFile, FileMode.Open));
						XmlProject projectXML = new XmlProject();
						projectXML.Read(reader);
						Data = projectXML.Data;
						reader.Close();
					
						isWCECabinet = Data.Files.Count > 0;
					}
				}
				else
				{
					if (extractConfigFile(idxFile, Utils.GetTempPath()))
					{
						string configFile = Utils.GetTempPath() + CmarcArchiver.ModifySlashToCak(idxFile);
						BinaryReader reader = new BinaryReader(new FileStream(configFile, FileMode.Open));
						Encoded_INF projectINF = new Encoded_INF();
						projectINF.Read(reader);
						Data = projectINF.Data;
						reader.Close();
					
						isWCECabinet = Data.Files.Count > 0;
					}
				}
				
				#endregion
				#region CreateList
				if (isWCECabinet)
				{
					for (int i = 0; i < Data.Files.Count; i++)
					{
						FileEntry fe = Data.Files.File((short)i);
						DirEntry de = Data.Dirs.ID(fe.DirID);
						String Directory = Utils.AppendSlash(Data.Strings.ParseString(de.Value));
						Directory = "\\" + Directory;
						
						Debug.WriteLine(Utils.ExtractFileExt(fe.ShortPath) + '=' + Directory + fe.Path);
						NameList.Add(Utils.ExtractFileExt(fe.ShortPath), Directory + fe.Path);						
					}
				#endregion
				#region Matching				
				if (isWCECabinet)
				foreach(ArchiverBase.INDIVIDUALINFO sInfo in FileNameList)
					if (NameList.ContainsKey(Utils.ExtractFileExt(sInfo.szFileName)))
					{
						SrcNameList.Add(Utils.ExtractFileExt(subInfo.szFileName), sInfo.szFileName);
						if (Utils.MatchMask((string)NameList[Utils.ExtractFileExt(sInfo.szFileName)], mask, true))
								OnItemList(this, new ItemListEventArgs(this,
								                                       new ContentType(ArchiveName, sInfo.dwOriginalSize, sInfo.dwCompressedSize,
								                                                       Cake3.Utils.DosDateToDateTime(sInfo.wDate, sInfo.wTime), sInfo.dwCRC,
								                                                       (string)NameList[Utils.ExtractFileExt(sInfo.szFileName)], false)) );
					}
				#endregion					
				}				
			}			
			return true;
		}
		
		public void OutputMessage(string message)
		{
			string[] output	= message.ToString().Split((Char)(10));
			foreach (string s in output)
			{
				string text = s.Trim();
				if (text != "")
					OnMessage(this, new MessageEventArgs(null, text));
			}
		}
		
		public override bool Extract(Cake3.ExtractOptions options) 
		{ 	
			Open();
			List("*");
			Close();
			
			DispMessage(Defines.ErrorMessage("PROCESSEXTR"), archiveName);	
			if (isWCECabinet)
			{							
				string command = arcBase.GetExtractCommand(new ExtractOptions(options.archiveName, 
				                                                              Utils.GetTempPath(), true), "*");
				StringBuilder output = new StringBuilder(4096);
				Int32 retVal = arcBase._ArchiverExec(IntPtr.Zero, command, output, (UInt32)output.Capacity);			
//				ErrorMessage ec = Defines.ErrorMessage(retVal);
//				if (ec.ErrorName != "NOERROR")
//				{
//					OnError(this, new ErrorEventArgs(this, ec));
//					return false;
//				}				
				foreach (string mask in options.extractItem)
					foreach (string key in NameList.Keys)
					{
						if (Utils.MatchMask((string)NameList[key], mask))
						{							
							string srcFile = Utils.GetTempPath() + SrcNameList[key];
							string destFile = options.ExtractFolderParsed + (string)NameList[key];
							Utils.MakeDirectory(Utils.ExtractFilePath(destFile));							
							if (Utils.FileExists(srcFile))
								Utils.CopyFile(srcFile, destFile);
							else return false;
						}
					}
				
			}
			else
			foreach (string file in options.extractItem)
			{
				string command = arcBase.GetExtractCommand(options, CmarcArchiver.ModifySlashFromCak(file));
				Debug.WriteLine(command);
				if (command == "")
					return false;
				StringBuilder output = new StringBuilder(4096);
				Int32 retVal = arcBase._ArchiverExec(IntPtr.Zero, command, output, (UInt32)output.Capacity);			
				ErrorMessage ec = Defines.ErrorMessage(retVal);
				
				OutputMessage(output.ToString());										
			
				if (ec.ErrorName != "NOERROR")
				{
					OnError(this, new ErrorEventArgs(this, ec));
					return false;
				}
				
			}
			return true; 
		}
		
		
	}
}
