using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace QuickZip.InstallBuilder
{
    internal class FileTools
    {
        public static Byte[] String2ByteArray(string value)
        {
            Byte[] retVal = new Byte[value.Length / 2];
            for (int i = 0; i < retVal.Length; i++)
            {
                retVal[i] = Convert.ToByte(value.Substring(i*2,2) , 16);
            }
            return retVal;
        }
        public static String Int16Array2String(Int16[] value)
        {
            String temp = "";
            for (int i = 0; i < value.Length; i++)
            {
                temp += ("\\"+Convert.ToString(value[i]));
            }
            if (temp != "")
                { return temp.Substring(1); }
            return "";
        }
        public static String ByteArray2String(Byte[] value)
        {
            String temp = "";
            for (int i = 0; i < value.Length; i++)
            {
                if (value[i] < 10)
                    temp += ("0" + Convert.ToString(value[i], 16).ToUpper());
                else
                    temp += ("" + Convert.ToString(value[i], 16).ToUpper());
            }
            if (temp != "")
                { return temp.Substring(0); }
            return "";
        }
        public static String ByteArray2String(Byte[] value, char seperator)
        {
            String temp = "";
            for (int i = 0; i < value.Length; i++)
            {
                if (value[i] < 10)
                    temp += (seperator + "0" + Convert.ToString(value[i], 16).ToUpper());
                else
                    temp += (seperator + "" + Convert.ToString(value[i], 16).ToUpper());
            }
            if (temp != "")
            { return temp.Substring(1); }
            return "";
        }
        public static String MultiString2String(String[] value)
        {
            String retVal = "";
            foreach (string s in value)
            {
                //retVal += s + (char)(0x2623) + (char)(0x0080) + (char)(0x0080);
                //retVal += s +  (char)(9763) + (char)(128) + (char)(128);
                retVal += s + "ï€€";    
            }
            return retVal;
        }
        public static String[] String2MultiString(String value)
        {
            return value.Split(',');
        }
        public static String StringArray2String(String[] value)
        {
            String temp = "";
            for (int i = 0; i < value.Length; i++)
            {                
                temp += (',' + value[i]);
            }
            if (temp != "")
                { return temp.Substring(1); }
            return "";
        }    
        public static String ReadString(BinaryReader reader, int length)
        {
            if (length <= 0)
            {
                return "";
            }

            Char[] buf = new Char[length];

            int count = reader.Read(buf, 0, length);

            if (count == length)
            {
                StringBuilder sb = new StringBuilder();
                sb.Append(buf);
                return sb.ToString().Replace("\0","");
            }
            else
            {
                return "";
            }
        }
        public static string ReadString(BinaryReader reader)
        {
            String k = "";            
            char c = reader.ReadChar();
            while (c != 0)
            {
                k += c;
                c = reader.ReadChar();
            }
            
            return k;
        }
        public static Byte[] ReadBytes(BinaryReader reader, int Length)
        {
            return reader.ReadBytes(Length);
        }
        public static Int32 ReadInt32(BinaryReader reader)
        {
            return reader.ReadInt32();
        }
        public static UInt32 ReadUInt32(BinaryReader reader)
        {
            return reader.ReadUInt32();
        }
        public static Int16 ReadInt16(BinaryReader reader)
        {
            return reader.ReadInt16();
        }

        public static void WriteString(BinaryWriter writer, String value, int Length)
        {
            if (value != "")
            {
                String s = value.Substring(0, Length);
                for (int i = 0; i < s.Length; i++) 
                {
                    writer.Write(s[i]);
                }                
            }
        }
        public static void WriteString(BinaryWriter writer, String value)
        {
            if (value != "")
            {
                WriteString(writer, value + "\0", value.Length + 1);
            }
        }
        public static void WriteInt16(BinaryWriter writer, Int16 value)
        {
            writer.Write((Int16)value);
        }
        public static void WriteInt32(BinaryWriter writer, Int32 value)
        {
            writer.Write((Int32)value);
        }
        public static void WriteUInt32(BinaryWriter writer, UInt32 value)
        {
            writer.Write((UInt32)value);
        }
        public static void WriteBytes(BinaryWriter writer, Byte[] value)
        {
            writer.Write(value);
        }
    }
}
