using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Reflection;
using System.Text;
using QuickZip.InstallBuilder;

namespace QuickZip.ThemeBuilder
{
    public enum DisplayMode { VGA, QVGA, VGA_Portrait, VGA_Landscape, QVGA_Portrait, QVGA_Landscape }

    public class ThemeData
    {
        public Color[] themeColors = new Color[41]; //0..40, 0 is not used.  
        public static String tdywater = "tdywater.gif";
        public String backGroundBitmap = tdywater;
        
        public Color todayText
        {
            get
            {
                return themeColors[4];
            }
            set
            {
                themeColors[4] = value;
            }
        }           //4  Today text, Text
        public Color navigationBar1
        {
            get
            {
                return themeColors[5];
            }
            set
            {
                themeColors[5] = value;
            }
        }      //5  Navigation Bar, Color 1
        public Color today1
        {
            get
            {
                return themeColors[6];
            }
            set
            {
                themeColors[6] = value;
            }
        }              //6  Today text, Color 1
        public Color command1
        {
            get
            {
                return themeColors[7];
            }
            set
            {
                themeColors[7] = value;
            }
        }            //7  Command bar, Color 
        public Color navigationBar2
        {
            get
            {
                return themeColors[8];
            }
            set
            {
                themeColors[8] = value;
            }
        }      //8  Navigation Bar, Color 2
        public Color navigationBarText
        {
            get
            {
                return themeColors[9];
            }
            set
            {
                themeColors[9] = value;
            }
        }   //9  Navigation Bar, Text
        public Color navigationTray
        {
            get
            {
                return themeColors[10];
            }
            set
            {
                themeColors[10] = value;
            }
        }      //10 Navigation Tray, Color 1
        public Color navigationTrayBack
        {
            get
            {
                return themeColors[11];
            }
            set
            {
                themeColors[11] = Color.FromArgb(192, 192, 192);
            }
        }  //11 Notification Tray background                               (R)
        public Color navigationIconHigh
        {
            get
            {
                return themeColors[12];
            }
            set
            {
                themeColors[12] = Color.FromArgb(128, 128, 128);
            }
        }  //12 Notification icon highlight                                (R)
        public Color message1
        {
            get
            {
                return themeColors[13];
            }
            set
            {
                themeColors[13] = value;
            }
        }            //13 Message, Color 1
        public Color message2
        {
            get
            {
                return themeColors[14];
            }
            set
            {
                themeColors[14] = value;
            }
        }            //14 Message, Color 2
        public Color listLeft2
        {
            get
            {
                return themeColors[15];
            }
            set
            {
                themeColors[15] = value;
            }
        }           //15 Notes/Tasks/etc List background color left 2               (E)
        public Color listRight2
        {
            get
            {
                return themeColors[16];
            }
            set
            {
                themeColors[16] = value;
            }
        }          //16 Notes/Tasks/etc List background color right 2              (E)
        public Color importantMessage1
        {
            get
            {
                return themeColors[25];
            }
            set
            {
                themeColors[25] = value;
            }
        }   //25 Important message, Color 1
        public Color importantMessage2
        {
            get
            {
                return themeColors[26];
            }
            set
            {
                themeColors[26] = value;
            }
        }   //26 Important message, Color 2
        public Color messageText
        {
            get
            {
                return themeColors[27];
            }
            set
            {
                themeColors[27] = value;
            }
        }         //27 Normal Notification title text (works in 2002 and 2003)    (E)
        public Color importantMessageText
        {
            get
            {
                return themeColors[28];
            }
            set
            {
                themeColors[28] = value;
            }
        }//28 Critical Notification title text (works in 2002 and 2003)  (E)
        public Color listLeft1
        {
            get
            {
                return themeColors[36];
            }
            set
            {
                themeColors[36] = value;
            }
        }           //36 Notes/Tasks/etc List background color left 1               (E)
        public Color listRight1
        {
            get
            {
                return themeColors[37];
            }
            set
            {
                themeColors[37] = value;
            }
        }          //37 Notes/Tasks/etc List background color right 1              (E)
        public Color unknown
        {
            get
            {
                return themeColors[38];
            }
            set
            {
                themeColors[38] = Color.FromArgb(194, 6, 5); 
            }
        }             //38 Spiral.tsk that comes with 2003 sets it to c2,06,05        (R)
        public Color startMenuText
        {
            get
            {
                return themeColors[39];
            }
            set
            {
                themeColors[39] = value;
            }
        }       //39 Start Menu Text                                            (E)
        public Color dots
        {
            get
            {
                return themeColors[40];
            }
            set
            {
                themeColors[40] = value;
            }
        }                //40 Tap-and-hold dots                                          (E)

        public ThemeData()
        {
            todayText           = Color.DarkBlue;
            navigationBar1      = Color.FromArgb(0, 128, 255);
            today1              = Color.LightBlue;
            command1            = Color.FromArgb(185, 201, 255);
            navigationBar2      = Color.FromArgb(0, 0, 160); 
            navigationBarText   = Color.White;
            navigationTray      = Color.FromArgb(228, 78, 5);
            navigationTrayBack  = Color.FromArgb(192, 192, 192);
            message1            = Color.FromArgb(0, 0, 247);
            message2            = Color.FromArgb(0, 0, 247);
            listLeft2           = Color.FromArgb(255, 255, 255);
            listRight2          = Color.FromArgb(244, 240, 236);
            importantMessage1   = Color.FromArgb(176, 0, 84);
            importantMessage2   = Color.FromArgb(255, 0, 0);
            messageText         = Color.FromArgb(255, 255, 255);
            importantMessageText= Color.FromArgb(255, 255, 255);
            listLeft1           = Color.FromArgb(254, 254, 255);
            listRight1          = Color.FromArgb(217, 204, 192);
            unknown             = Color.FromArgb(194, 6, 5);
            startMenuText       = Color.FromArgb(255, 255, 255);
            dots                = Color.FromArgb(0, 0, 247);
        }
        public void SetThemeColors(Color[] input)
        {
            if (input.Length != 41) //0 - 40
                throw new Exception("ThemeData input is not a length 41 array!");
            themeColors = input;
        }
        public void DebugUnit()
        {
            for (int i = 0; i < themeColors.Length; i++)
                if (ThemeData.ValidEntry(i))
                    Console.WriteLine(i.ToString() + " - " + Convert.ToString(themeColors[i]));
        }
        public static bool ValidEntry(Int32 id)
        {
            if (id < 4)
                return false;
            if ((id > 16) && (id < 25))
                return false;
            if ((id > 28) && (id < 36))
                return false;
            return true;            
        }        
    }

    public class ThemePreview
    {
        Int32 Multiplier = 1;
        Size backgroundSize = new Size(320, 294); //VGA 640*588
        Int32 barHeight = 26;
        Font mainFont = new Font("Microsoft Sans Serif", 8, FontStyle.Bold);
        public ThemeData themeData = new ThemeData();
        public DisplayMode dispMode;


        public ThemePreview()
        {
            ChangeMode(DisplayMode.QVGA_Portrait);
        }

        private float centreY(Graphics g)
        {
            return (float)(barHeight - g.MeasureString("Start", mainFont).Height) / 2;
        }

        public Size FullSize()
        {
            return new Size(backgroundSize.Width, backgroundSize.Height + (barHeight * 2));
        }

        public Rectangle navigationBarRect()
        {
            return new Rectangle(0, 0, backgroundSize.Width, barHeight);
        }
        public Rectangle backGroundRect()
        {
            return new Rectangle(0, barHeight, backgroundSize.Width, backgroundSize.Height);
        }
        public Rectangle commandBarRect()
        {
            return new Rectangle(0, FullSize().Height - barHeight, backgroundSize.Width, barHeight);
        }
        public float clockX()
        {
            return (float)(backgroundSize.Width * 0.789916);
        }
        public Int32 CritialX()
        {
            return (Int32)(clockX() - barHeight - barHeight);
        }
        public Int32 VoiceX()
        {
            return (Int32)(clockX() - barHeight);
        }

        public SizeF TextSize2(Graphics g, string aText, Font aFont)
        {
            SizeF defSize = g.MeasureString(aText, aFont);
            Int32 precision = (Int32)(defSize.Width / 50);
            if (precision == 0) { precision = 1; }

            Bitmap b = new Bitmap((int)defSize.Width + 1, (int)defSize.Height + 1);
            Graphics tempGraphics = Graphics.FromImage(b);
            try
            {
                tempGraphics.FillRectangle(new SolidBrush(Color.White), new Rectangle(0, 0, (int)defSize.Width + 1, (int)defSize.Height + 1));
                tempGraphics.DrawString(aText, aFont, new SolidBrush(Color.Black), new PointF(0, 0));
                for (int x = (int)defSize.Width - 1; x > 0; x = x - precision)
                {
                    for (int y = (int)defSize.Height - 1; y > 0; y--)
                    {
                        if ((b.GetPixel(x, y).R < 200))
                        {
                            return new SizeF((float)x, defSize.Height);
                        }
                    }
                }
            }
            catch
            {
                return defSize;
            }
            finally
            {
                tempGraphics.Dispose();
                b.Dispose();
            }
            return defSize;
        }

        public Bitmap previewBitmap(bool startMenu)
        {
            Bitmap retVal = new Bitmap(FullSize().Width, FullSize().Height);
            String aName = System.Reflection.Assembly.GetExecutingAssembly().GetModules()[0].FullyQualifiedName;                
            String progPath = System.IO.Path.GetDirectoryName(aName) + '\\';
            String imgPath = progPath + "Data\\";
            Bitmap flagBitmap = new Bitmap(imgPath+"Flag.png"); flagBitmap.MakeTransparent(Color.Black);
            Bitmap critialBitmap = new Bitmap(imgPath+"Critial.png"); critialBitmap.MakeTransparent(Color.Black);
            Bitmap voiceBitmap = new Bitmap(imgPath+"Voice.png"); voiceBitmap.MakeTransparent(Color.Black);
            Bitmap clockBitmap = new Bitmap(imgPath+"Clock.png"); clockBitmap.MakeTransparent(Color.White);
            if (themeData.backGroundBitmap == ThemeData.tdywater)
                themeData.backGroundBitmap = imgPath + themeData.backGroundBitmap;
            Bitmap backBitmap = new Bitmap(themeData.backGroundBitmap);
            

            Graphics g = Graphics.FromImage(retVal);
            try
            {
                g.FillRectangle(new LinearGradientBrush(new Point(0, 0),
                    new Point(backgroundSize.Width, barHeight), themeData.navigationBar1, themeData.navigationBar2),
                    navigationBarRect());                
                g.DrawImage(flagBitmap, new Rectangle(0, 0, barHeight, barHeight), new Rectangle(0, 0, flagBitmap.Width, flagBitmap.Height), GraphicsUnit.Pixel);
                g.DrawImage(critialBitmap, new RectangleF(CritialX(), 0, barHeight, barHeight), new Rectangle(0, 0, critialBitmap.Width, critialBitmap.Height), GraphicsUnit.Pixel);
                g.DrawImage(voiceBitmap, new RectangleF(VoiceX(), 0, barHeight, barHeight), new Rectangle(0, 0, voiceBitmap.Width, voiceBitmap.Height), GraphicsUnit.Pixel);
                g.DrawString("08:48", mainFont, new SolidBrush(themeData.navigationBarText), clockX(), centreY(g));

                g.DrawLine(new Pen(themeData.navigationBarText), barHeight + 1, 0, barHeight + 1, barHeight);
                g.DrawString("Start", mainFont, new SolidBrush(themeData.navigationBarText), barHeight + 2, centreY(g));
                
                g.FillRectangle(new TextureBrush(backBitmap), backGroundRect());
                
                g.DrawImage(backBitmap, backGroundRect().Left, backGroundRect().Top);

                g.FillRectangle(new SolidBrush(themeData.command1), commandBarRect());
                g.DrawString("New", mainFont, new SolidBrush(themeData.todayText), 2, commandBarRect().Top + centreY(g));

                g.DrawRectangle(new Pen(new SolidBrush(themeData.today1)), navigationBarRect().Left, navigationBarRect().Top, navigationBarRect().Width - 1, navigationBarRect().Height - 1);
                g.DrawRectangle(new Pen(new SolidBrush(themeData.today1)), backGroundRect().Left, backGroundRect().Top, backGroundRect().Width - 1, backGroundRect().Height);
                g.DrawRectangle(Pens.Black, 0, 0, FullSize().Width - 1, FullSize().Height - 1);
                g.DrawRectangle(Pens.Black, commandBarRect().Left, commandBarRect().Top, commandBarRect().Width - 1, commandBarRect().Height - 1);

                g.DrawImage(clockBitmap, new RectangleF(0, backGroundRect().Top, clockBitmap.Width * Multiplier, clockBitmap.Height * Multiplier), 
                    new Rectangle(0, 0, clockBitmap.Width, clockBitmap.Height), GraphicsUnit.Pixel);
                g.DrawString("Monday, August 14, 2006", mainFont, new SolidBrush(themeData.todayText), barHeight + 2, backGroundRect().Top + (clockBitmap.Height * Multiplier) - TextSize2(g, "Test", mainFont).Height);
                g.DrawLine(new Pen(themeData.today1), 0, backGroundRect().Top + (clockBitmap.Height * Multiplier) + 3, backGroundRect().Width, backGroundRect().Top + (clockBitmap.Height * Multiplier) + 3);

                if (startMenu)
                {
                    Bitmap menuBitmap;
                    switch (dispMode)
                    {
                        case DisplayMode.QVGA_Portrait:
                            menuBitmap = new Bitmap(imgPath + "MenuP.png");
                            break;
                        case DisplayMode.VGA_Portrait:
                            menuBitmap = new Bitmap(imgPath + "MenuP.png");
                            break;
                        default:
                            menuBitmap = new Bitmap(imgPath + "MenuL.png");
                            break;
                    }
                    menuBitmap.MakeTransparent(Color.White);
                    RectangleF menuRect = new RectangleF(0, backGroundRect().Top, menuBitmap.Width * Multiplier, menuBitmap.Height * Multiplier);
                    g.Clip = new Region(menuRect);
                    g.FillRectangle(new TextureBrush(backBitmap), menuRect);
                    g.DrawImage(backBitmap, backGroundRect().Left, backGroundRect().Top);

                    g.DrawImage(menuBitmap, new RectangleF(0, backGroundRect().Top, menuBitmap.Width * Multiplier, menuBitmap.Height * Multiplier),
                    new Rectangle(0, 0, menuBitmap.Width, menuBitmap.Height), GraphicsUnit.Pixel);
                }
            }
            finally
            {
                flagBitmap.Dispose();
                critialBitmap.Dispose();
                voiceBitmap.Dispose();
                clockBitmap.Dispose();
                backBitmap.Dispose();
                g.Dispose();
            }
            return retVal;
        }

        public void ChangeMode(DisplayMode mode)
        {
            dispMode = mode;
            switch (mode)
            {
                case DisplayMode.VGA:
                    backgroundSize = new Size(640, 536);
                    barHeight = 52;
                    mainFont = new Font("Microsoft Sans Serif", 16, FontStyle.Bold);
                    Multiplier = 2;
                    break;
                case DisplayMode.VGA_Portrait:
                    backgroundSize = new Size(480, 536);
                    barHeight = 52;
                    mainFont = new Font("Microsoft Sans Serif", 16, FontStyle.Bold);
                    Multiplier = 2;
                    break;
                case DisplayMode.VGA_Landscape:
                    backgroundSize = new Size(640, 376);
                    barHeight = 52;
                    mainFont = new Font("Microsoft Sans Serif", 16, FontStyle.Bold);
                    Multiplier = 2;
                    break;

                case DisplayMode.QVGA:
                    backgroundSize = new Size(320, 268);
                    barHeight = 26;
                    mainFont = new Font("Microsoft Sans Serif", 8, FontStyle.Bold);
                    Multiplier = 1;
                    break;
                case DisplayMode.QVGA_Portrait:
                    backgroundSize = new Size(240, 268);
                    barHeight = 26;
                    mainFont = new Font("Microsoft Sans Serif", 8, FontStyle.Bold);
                    Multiplier = 1;
                    break;
                case DisplayMode.QVGA_Landscape:
                    backgroundSize = new Size(320, 188);
                    barHeight = 26;
                    mainFont = new Font("Microsoft Sans Serif", 8, FontStyle.Bold);
                    Multiplier = 1;
                    break;
            }
        }


    }
}
