/*
 * Created by SharpDevelop.
 * User: LYCJ
 * Date: 18/12/2006
 * Time: 0:09
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using ICSharpCode.SharpZipLib;
using Cake3;

namespace Cake3.SharpZipLib
{
	/// <summary>
	/// Description of ArchiverBase.
	/// </summary>
	public abstract class ArchiverBase
	{
		internal string archiveName;
		
		internal string ModifySlashToCak(string input)
		{
			return Utils.AppendFrontSlash( input.Replace('/','\\') );
		}
		
		internal string ModifySlashFromCak(string input)
		{
			if (input == "*") return "/*";
			input = Utils.RemoveFrontSlash(input);
			input = input.Replace('\\','/');			
			return input;
		}

			
		public ArchiverBase()
		{
		}
		
		public abstract bool Open();
		public abstract bool Close();
		public abstract bool List(string mask);
		public abstract bool Extract(ExtractOptions options);
		public abstract bool Delete(DeleteOptions options);
		public abstract bool Add(AddOptions options);
		public abstract bool Test();
		public virtual void setArchiveName(string anArchive)
		{
			archiveName = anArchive;
		}
	}
}
