/*
 * Created by SharpDevelop.
 * User: LYCJ
 * Date: 2/12/2006
 * Time: 23:43
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using ICSharpCode.SharpZipLib;
using Cake3;

namespace Cake3.SharpZipLib
{
	/// <summary>
	/// Description of SZLArchiver.
	/// </summary>
	public class SZLArchiver : CakArchiver
	{
		internal override string name {	get { return "sharpziplib"; }}
		ArchiverBase arcBase;
		private static string DllName = "ICSharpCode.SharpZipLib.dll";
		
		public SZLArchiver() : base()
		{
		}
				
		public override List<ArchiveType> SupportedArchiveTypes()
		{
			List<ArchiveType> retVal = new List<ArchiveType>();	
			if (Utils.verifyDllPath(DllName))
				retVal.Add(new ArchiveType(name, "zip,ear,jar,war,wsz,mskin,bsz,wal,wmz", 0, true, true, true, true));
			return retVal;
		}
		
		public override bool Open()
		{
			if (arcBase == null) return false;			
			return arcBase.Open();
		}
		
		public override bool Close()
		{
			if (arcBase == null) return false;			
			return arcBase.Close();
		}
		
		public override bool List(string mask)
		{
			if (arcBase == null) return false;		
			DispMessage(Defines.ErrorMessage("PROCESSLIST"), archiveName);	
			return arcBase.List(mask);
		}
		
		internal override void setArchiveName(string anArchive)
		{
			base.setArchiveName(anArchive);
			if (Utils.ExtractFileExt(anArchive).ToLower() == ".zip")
				arcBase = new ZipBase(this);
			
			if (arcBase != null)
				arcBase.setArchiveName(anArchive);
			
			canList = true;
			canExtract = true;
			canAdd = true;
			canAlarmOverwrite = true;
		}
		
		public override bool Extract(ExtractOptions options)
		{
			if (arcBase == null) return false;		
			DispMessage(Defines.ErrorMessage("PROCESSEXTR"), archiveName);	
			return arcBase.Extract(options);
		}
		
		public override bool Delete(DeleteOptions options)
		{
			if (arcBase == null) return false;		
			DispMessage(Defines.ErrorMessage("PROCESSDEL"), archiveName);	
			return arcBase.Delete(options);
		}
		
		public override bool Add(AddOptions options)
		{
			if (arcBase == null) return false;		
			DispMessage(Defines.ErrorMessage("PROCESSADD"), archiveName);	
												
			return arcBase.Add(options);
		}
		
		public override bool Test()
		{
			if (arcBase == null) return false;		
			DispMessage(Defines.ErrorMessage("PROCESSTEST"), archiveName);	
			return arcBase.Test();
		}
				
		
		
	}
}
