/*
 * Created by SharpDevelop.
 * User: LYCJ
 * Date: 29/11/2006
 * Time: 17:24
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Text;
using Cake3;

namespace Cake3.Sqx
{
	public class Kernel
	{
		public const Int32 MAXPATH = 260;
	}
	
	[StructLayout(LayoutKind.Sequential, Pack=1, CharSet=CharSet.Ansi)]
	public struct SQX_FILETIME 
	{
		public bool fBlockPresent;
		public Int64 ftCreationTime;
		public Int64 ftLastAccessTime;
		public Int64 ftLastWriteTime;			
	}								
		
	[StructLayout(LayoutKind.Sequential, Pack=1, CharSet=CharSet.Ansi)]
	public struct SQX_ARCNODE
	{
		[MarshalAs(UnmanagedType.LPStr)]public string pszFileName;
		public Int32 dwFileNameLen;
		[MarshalAs(UnmanagedType.LPStr)]public string pszExtraName;
		public Int32 dwExtraNameLen;
		public Int32 dwFileNameType;
		public Int64 dwlSize;
		public Int64 dwlSizeOrig;
		public Int32 dwDosFileTime;
		public Int32 dwAttributes;
		public Int32 dwArcerVersion;
		public Int32 dwFileCRC;
		public Int32 dwHostOS;
		public Int32 dwMethod;
		public Int32 dwCommentLen;
		[MarshalAs(UnmanagedType.LPStr)]public string pszComment;
		public bool fEncrypted;
		public bool fTagged;
		public Int32 dwMappedMethod;
		public Int32 dwExtendedError;
		public SQX_FILETIME win32FileTime;
	}
	
	[StructLayout(LayoutKind.Sequential, Pack=1, CharSet=CharSet.Ansi)]
	public struct SQX_ARCLISTNODE
	{
		public IntPtr pNext; 	//SQX_ARCLISTNODE
		public IntPtr pArcNode; //SQX_ARCNODE
	}
	
	[StructLayout(LayoutKind.Sequential, Pack=1, CharSet=CharSet.Ansi)]
	public struct SQX_AVINFO
	{
		public bool fAVInfoPresent;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 255)]
		public string szAV_ID;
		public Int64 ftCreationTime;
	}
	
	[StructLayout(LayoutKind.Sequential, Pack=1, CharSet=CharSet.Ansi)]
	public struct SQX_ARCINFO
	{
		public UInt32 cbSize;
		public UInt32 dwFileFormat;
		public UInt32 dwArcerMajorVersion;
		public UInt32 dwArcerMinorVersion;
		public UInt32 dwDictionarySize;
		public bool fRecoveryData;
		public UInt32 dwEncryption;
		public bool fSolid;
		public UInt32 dwHostOS;
		public UInt32 dwTotalFiles;
		public Int64 dwlCompressedSize;
		public Int64 dwlUncompressedSize;
		public Int32 iRatio;
		public bool fHeaderEncrypted;
		public bool fIsMultiVolume;
		public bool fArchiveComment;
		public bool fFileComments;
		public SQX_AVINFO avInfo;
	}
	
	[StructLayout(LayoutKind.Sequential, Pack=1, CharSet=CharSet.Ansi)]
	public struct SQX_ARCLIST
	{
		public UInt32 dwItemCount;
		public IntPtr pHead;
		public IntPtr pTail;
	}
	
	[StructLayout(LayoutKind.Sequential, Pack=1, CharSet=CharSet.Ansi)]
	public struct SQX_EXTRACTOPTIONS
	{
		public Int32 cbSize;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = Kernel.MAXPATH)]public string szPassword;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = Kernel.MAXPATH)]public string szPasswordHeader;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = Kernel.MAXPATH)]public string szTempDir;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = Kernel.MAXPATH)]public string szRelativePath;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = Kernel.MAXPATH)]public string szOutputPath;
		public bool fResetArchiveAttribute;
		public bool fOverwriteAlways;
		public bool fKeepBrokenFiles;
		public bool fCreateFolders;
		public bool fRestoreACLs;
		public bool fRestoreStreams;
		public bool fRestoreUnicodeNames;
		public bool fRestoreWin32FileTimes;
		public bool fRestoreDirectoryTimeStamps;
		public bool fAutoRestoreComments;
		public bool fSetZoneID;		
		
	}

	[StructLayout(LayoutKind.Sequential, Pack=1, CharSet=CharSet.Ansi)]
	public struct SQX_CALLBACKINFO
	{
		public UInt32 dwCallbackType;
		[MarshalAs(UnmanagedType.LPStr)]public string pszSourceFileName;
		[MarshalAs(UnmanagedType.LPStr)]public string pszTargetFileName;
		public Int32 iProgress;
		public IntPtr pFindDataExist;		//LPWIN32_FIND_DATA
		public IntPtr pFindDataReplace;		//LPWIN32_FIND_DATA
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = Kernel.MAXPATH)]public string szCryptKey;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = Kernel.MAXPATH)]public string szOldCryptKey;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = Kernel.MAXPATH)]public string szCryptFileName;
		public UInt32 dwTotalSize;
		public UInt32 dwDiskNum;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = Kernel.MAXPATH)]public string szNextDiskPath;
		public UInt32 dwSignal;
		public Int64 dwlBlockSize;
	}
	
	
	public delegate int dSqxCallback(IntPtr pParam, ref SQX_CALLBACKINFO CallbackInfo);
	
	[StructLayoutAttribute( LayoutKind.Sequential, CharSet = CharSet.Ansi )]
	public struct Delegate_Wrapper
	{
    	[MarshalAsAttribute(UnmanagedType.FunctionPtr)]
    	public dSqxCallback  _delegate;
	};
}
